#SkeletonHorse
execute as @e[type=skeleton_horse,tag=!is_skeleton_horse,sort=random] at @s run function undead_horse:skeleton_horse/skeleton_horse_spawn

#ZombieHorseWeakness
execute as @a[nbt={RootVehicle:{Entity:{id:"minecraft:zombie_horse"}}}] at @s run effect give @e[type=!player,type=!zombie_horse,distance=..7] minecraft:weakness 5 1

#ZombieHorseTrap
execute as @a at @s if predicate undead_horse:is_night if biome ~ ~ ~ #is_overworld run function undead_horse:zombie_horse/zombie_horse_spawn
execute as @e[type=minecraft:zombie_horse,tag=ZombieTrap] at @s if entity @a[distance=..10] run function undead_horse:zombie_horse/zombietrap

#DrownedHorse
execute as @e[type=zombie_horse] at @s if block ~ ~3 ~ water run function undead_horse:drowned_horse/submergecheck/check1
execute as @e[type=skeleton_horse, name=ZHJvd25lZGhvcnNl] at @s if block ~ ~3 ~ water run function undead_horse:drowned_horse/inwatercheck/check1
execute as @e[type=skeleton_horse, name=ZHJvd] at @s if block ~ ~3 ~ water run function undead_horse:drowned_horse/inwatercheck/check1
execute as @e[type=skeleton_horse, name=ZHJvd25lZGhvcnNl] at @s if entity @e[type=minecraft:lightning_bolt,distance=..3] run function undead_horse:drowned_horse/drownedattack/drownspecial
team join team1 @e[tag=isInvis]

#BoggedHorse
execute as @e[type=skeleton_horse] at @s if biome ~ ~ ~ swamp if block ~ ~ ~ water run function undead_horse:bogged_horse/inwatercheck/checks1
execute as @e[type=skeleton_horse] at @s if biome ~ ~ ~ mangrove_swamp if block ~ ~ ~ water run function undead_horse:bogged_horse/inwatercheck/checks1
execute as @e[type=minecraft:skeleton_horse,nbt={CustomName:'"Ym9nZ2VkIGhvcnNl"'}] at @s if entity @e[distance=..3,type=bogged] run function undead_horse:bogged_horse/bogged_curing
execute as @e[type=minecraft:skeleton_horse,nbt={CustomName:'"Ym9nZ2VkIGhvcnNl"'},scores={boggedCured=20}] at @s run function undead_horse:bogged_horse/bogged_trap
execute as @e[type=minecraft:skeleton_horse,nbt={CustomName:'"Ym9nZ2VkIGhvcnNl"'},scores={boggedCured=20}] run scoreboard players reset @s boggedCured


#StrayHorse
execute as @e[type=skeleton_horse] at @s if block ~ ~ ~ powder_snow run function undead_horse:stray_horse/suffocatecheck/checks1
execute as @e[type=skeleton_horse, name=c3RyYXlob3JzZQ] at @s if predicate undead_horse:is_snowing run function undead_horse:stray_horse/stray_special_biome
execute as @a[nbt={RootVehicle:{Entity:{id:"minecraft:skeleton_horse",CustomName:'"c3RyYXlob3JzZQ"'}}}] at @s run effect give @e[type=!player,type=!skeleton_horse,distance=..5] minecraft:slowness 5 1
execute as @a[nbt={RootVehicle:{Entity:{id:"minecraft:skeleton_horse",CustomName:'"c3RyYX"'}}}] at @s run effect give @e[type=!player,type=!skeleton_horse,distance=..5] minecraft:slowness 5 1
execute as @a[nbt={RootVehicle:{Entity:{id:"minecraft:skeleton_horse",CustomName:'"c3RyYXlob3JzZQ"'}}}] at @s run effect give @e[type=skeleton_horse,nbt={CustomName:'"c3RyYXlob3JzZQ"'}] minecraft:speed 5 1 true
execute as @a[nbt={RootVehicle:{Entity:{id:"minecraft:skeleton_horse",CustomName:'"c3RyYX"'}}}] at @s run effect give @e[type=skeleton_horse,nbt={CustomName:'"c3RyYX"'}] minecraft:speed 5 1 true

#ZombieHorseCuring
execute as @e[type=minecraft:zombie_horse,tag=!isWeak,nbt={active_effects:[{id:"minecraft:weakness"}]}] run tag @s add justWeak 
execute as @e[type=minecraft:zombie_horse,tag=!isWeak,nbt={active_effects:[{id:"minecraft:weakness"}]}] run scoreboard players set @e[type=zombie_horse,tag=justWeak] gcCount 0
execute as @e[type=minecraft:zombie_horse,tag=!isWeak,nbt={active_effects:[{id:"minecraft:weakness"}]}] run tag @s add isWeak 
execute as @e[type=minecraft:zombie_horse,tag=justWeak] run scoreboard players set @s weakTimer 1200
execute as @e[type=minecraft:zombie_horse,tag=justWeak] run tag @s remove justWeak
execute as @e[type=minecraft:zombie_horse,scores={weakTimer=1..}] run scoreboard players remove @s weakTimer 1
execute as @e[type=minecraft:zombie_horse,scores={weakTimer=0}] run tag @s remove isWeak
execute as @e[type=minecraft:zombie_horse,scores={weakTimer=0}] run scoreboard players reset @s weakTimer

execute as @e[type=item,nbt={Item:{id:"minecraft:golden_carrot"}}] at @s run execute as @e[type=zombie_horse,tag=isWeak,distance=..1] run function undead_horse:zombie_horse/zombie_horse_curing/carrot_detect
execute as @e[type=zombie_horse,tag=isWeak,scores={gcCount=5}] run tag @s add converting

execute as @e[type=minecraft:zombie_horse,scores={gcCount=5}] run scoreboard players reset @s gcCount

execute as @e[type=minecraft:zombie_horse,tag=converting] run function undead_horse:zombie_horse/zombie_horse_curing/conversion_start
execute as @e[type=minecraft:zombie_horse,tag=midconvert,scores={conversionTimer=..1199}] run scoreboard players add @s conversionTimer 1

execute as @e[type=minecraft:zombie_horse,scores={conversionTimer=1100}] run function undead_horse:zombie_horse/zombie_horse_curing/cool_textures/t1
execute as @e[type=minecraft:zombie_horse,scores={conversionTimer=1110}] run function undead_horse:zombie_horse/zombie_horse_curing/cool_textures/t2
execute as @e[type=minecraft:zombie_horse,scores={conversionTimer=1120}] run function undead_horse:zombie_horse/zombie_horse_curing/cool_textures/t3
execute as @e[type=minecraft:zombie_horse,scores={conversionTimer=1130}] run function undead_horse:zombie_horse/zombie_horse_curing/cool_textures/t4
execute as @e[type=minecraft:zombie_horse,scores={conversionTimer=1140}] run function undead_horse:zombie_horse/zombie_horse_curing/cool_textures/t5
execute as @e[type=minecraft:zombie_horse,scores={conversionTimer=1150}] run function undead_horse:zombie_horse/zombie_horse_curing/cool_textures/t6
execute as @e[type=minecraft:zombie_horse,scores={conversionTimer=1160}] run function undead_horse:zombie_horse/zombie_horse_curing/cool_textures/t7
execute as @e[type=minecraft:zombie_horse,scores={conversionTimer=1170}] run function undead_horse:zombie_horse/zombie_horse_curing/cool_textures/t8
execute as @e[type=minecraft:zombie_horse,scores={conversionTimer=1180}] run function undead_horse:zombie_horse/zombie_horse_curing/cool_textures/t9
execute as @e[type=minecraft:zombie_horse,scores={conversionTimer=1190}] run function undead_horse:zombie_horse/zombie_horse_curing/cool_textures/t10

execute as @e[type=minecraft:zombie_horse,tag=midconvert,scores={conversionTimer=1200}] run function undead_horse:zombie_horse/zombie_horse_curing/conversion_finish
execute as @e[type=minecraft:zombie_horse,tag=midconvert,scores={conversionTimer=1200}] run scoreboard players reset @s conversionTimer

#PiglinPatrols
execute as @a at @s if biome ~ ~ ~ #is_nether if predicate undead_horse:patrol_chance run function undead_horse:piglin_patrol/check_cycle/cycle1
execute as @e[type=minecraft:piglin,tag=JustSpawnedPiglin] at @s run summon hoglin ^ ^5 ^ {Passengers:[{id:piglin_brute,HandItems:[{id:"minecraft:golden_axe",count:1b},{}],ArmorItems:[{},{},{},{id:golden_helmet,count:1b}]}],Tags:["PiglinPatrol"]}
execute as @e[type=minecraft:piglin,tag=JustSpawnedPiglin] at @s run summon piglin ^1 ^ ^1 {HandItems:[{id:"minecraft:crossbow",count:1},{}],ArmorItems:[{},{},{},{id:"minecraft:golden_helmet",count:1}],Tags:["PiglinPatrol"]}
execute as @e[type=minecraft:piglin,tag=JustSpawnedPiglin] at @s run summon piglin ^-1 ^ ^1 {HandItems:[{id:"minecraft:crossbow",count:1},{}],ArmorItems:[{},{},{},{id:"minecraft:golden_helmet",count:1}],Tags:["PiglinPatrol"]}
execute as @e[type=minecraft:piglin,tag=JustSpawnedPiglin] at @s run summon piglin ^1 ^ ^2 {HandItems:[{id:"minecraft:golden_sword",count:1},{}],ArmorItems:[{},{},{},{id:"minecraft:golden_helmet",count:1}],Tags:["PiglinPatrol"]}
execute as @e[type=minecraft:piglin,tag=JustSpawnedPiglin] at @s run summon piglin ^-1 ^ ^2 {HandItems:[{id:"minecraft:golden_sword",count:1},{}],ArmorItems:[{},{},{},{id:"minecraft:golden_helmet",count:1}],Tags:["PiglinPatrol"]}
execute as @e[type=minecraft:piglin,tag=JustSpawnedPiglin] at @s run summon zombified_piglin ^-1 ^ ^-1 {HandItems:[{id:"minecraft:black_banner",count:1,components:{"minecraft:item_model":"udhoh:piglin_gonfalon","minecraft:banner_patterns":[{"pattern":"bricks","color":"black"},{"pattern":"bricks","color":"black"},{"pattern":"bricks","color":"gray"},{"pattern":"circle","color":"yellow"},{"pattern":"piglin","color":"black"},{"pattern":"border","color":"yellow"}]}},{id:"minecraft:golden_sword",count:1}],ArmorItems:[{},{},{},{id:"minecraft:golden_helmet",count:1}],Tags:["PiglinPatrol"],HandDropChances:[0.0f,1.0f]}
execute as @e[type=minecraft:piglin,tag=JustSpawnedPiglin] at @s run summon zombified_piglin ^1 ^ ^-1 {HandItems:[{id:"minecraft:golden_sword",count:1},{id:"minecraft:black_banner",count:1,components:{"minecraft:item_model":"udhoh:piglin_gonfalon","minecraft:banner_patterns":[{"pattern":"bricks","color":"black"},{"pattern":"bricks","color":"black"},{"pattern":"bricks","color":"gray"},{"pattern":"circle","color":"yellow"},{"pattern":"piglin","color":"black"},{"pattern":"border","color":"yellow"}]}}],ArmorItems:[{},{},{},{id:"minecraft:golden_helmet",count:1}],Tags:["PiglinPatrol"],HandDropChances:[0.0f,1.0f]}
tag @e[type=minecraft:piglin,tag=JustSpawnedPiglin] remove JustSpawnedPiglin

#WitherSkeletonHorse
execute as @a at @e[type=skeleton_horse, nbt=!{CustomName:'"c3RyYXlob3JzZQ"'},nbt=!{CustomName:'"ZHJvd25lZGhvcnNl"'},nbt=!{CustomName:'"c3RyYX"'},nbt=!{CustomName:'"ZHJvd"'},nbt=!{CustomName:'"d2l0aGVyIGhvcnNl"'},nbt=!{CustomName:'"Ym9nZ2VkIGhvcnNl"'},nbt=!{CustomName:'"Ym9nZ2V"'}] if predicate undead_horse:fortess if block ~ ~ ~ wither_rose at @s run function undead_horse:wither_horse/check_for_rose
execute as @e[type=wither_skeleton,tag=!is_wither_skeleton,sort=random] at @s run function undead_horse:wither_horse/wither_horse_spawn
execute as @a[nbt={RootVehicle:{Entity:{id:"minecraft:skeleton_horse",CustomName:'"d2l0aGVyIGhvcnNl"'}}}] at @s run effect clear @p wither
execute as @a[nbt={RootVehicle:{Entity:{id:"minecraft:skeleton_horse",CustomName:'"d2l0aGVyIGhvcnNl"'}}}] at @s run effect clear @e[type=skeleton_horse,nbt={CustomName:'"d2l0aGVyIGhvcnNl"'}] wither
